/*
 *  Project: LKH - lect3
 *  File: es3.c
 *  Date: 01/24/2006
 *  Author. R. Gioiosa
 */

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <asm/uaccess.h>
#include <linux/proc_fs.h>

#define MODULE_VERS "1.0"
#define MODULE_NAME "LKH-ES3"

#define DEBUG_ON

#ifdef DEBUG_ON
#define Dprintk(ARG...) printk(KERN_DEBUG MODULE_NAME ": " ARG)
#else
#define Dprintk(ARG...) 
#endif

static struct proc_dir_entry* lkh_pde;
static struct proc_dir_entry* entry;
static int es3_var = 10;

static int es3_read(char* page,char** start,off_t off,int count,int* eof,void* data)
{
  int written = 0;

  written = sprintf(page,"var = %d\n",es3_var);
  *start = page+off;
  if(strlen(page) == written)
    *eof = 1;
  Dprintk("es3_read done.\n");
  return written-off;

}

static int __init es3_init(void)
{
  lkh_pde = proc_mkdir("lkh",NULL);
  if(!lkh_pde)
    {
      printk(KERN_ERR "%s: error creating proc_dir entry!\n",MODULE_NAME);
      goto err;
    }
  Dprintk("proc dir created\n");
  entry = create_proc_entry("foo",0444,lkh_pde);
  if(!entry)
    {
      printk(KERN_ERR "%s: error creating proc_entry!\n",MODULE_NAME);
      goto err_dir;
    }
  entry->data = NULL;
  entry->owner = THIS_MODULE;
  entry->read_proc = es3_read;
  entry->write_proc = NULL;
  Dprintk("proc entry created\n");
  Dprintk("module loaded\n");
  return 0;
 err_dir:
  remove_proc_entry("lkh",NULL);
  Dprintk("proc dir removed\n");
 err:
  return -1;
}

static void __exit es3_exit(void)
{
  remove_proc_entry("foo",lkh_pde);
  Dprintk("proc entry removed\n");
  remove_proc_entry("lkh",NULL);
  Dprintk("proc dir removed\n");
  Dprintk("module unloaded\n");
}

module_init(es3_init);
module_exit(es3_exit);

MODULE_AUTHOR("Roberto Gioiosa");
MODULE_DESCRIPTION("Linux Kernel Hacking 06 - Es3");
MODULE_LICENSE("GPL");
MODULE_VERSION(MODULE_VERS);
